local tmp_vec1 = Vector3()
local mrot1 = Rotation()

local CopLogicBase = CopLogicBase
function CopLogicBase._angle_and_dis_chk(handler, settings, data, my_pos)
	local attention_pos = handler:get_detection_m_pos()
	local dis = mvector3.direction(tmp_vec1, my_pos, attention_pos)
	local my_data = data.internal_data
	local my_head_rot = data.unit:movement():m_head_rot()

	if not my_data.vision then
		Application:error("CopLogicBase._angle_and_dis_chk: Unit missing vision property. ", inspect(my_data.unit))

		return
	end

	if settings.notice_requires_FOV and my_data.vision.cone_1.distance < dis / 3 and my_data.vision.cone_2.distance < dis / 3 and my_data.vision.cone_3.distance < dis / 3 then
		return
	end

	mrotation.set_look_at(mrot1, tmp_vec1, math.UP)

	local angle = math.abs(180 - math.abs(mrot1:yaw() - my_head_rot:yaw()))
	local angle_z = mvector3.angle(my_head_rot:y(), tmp_vec1)
	local angle_max = my_data.vision.cone_3.angle
	local angle_multiplier = angle / angle_max
	local range_mul = settings.range_mul or 1
	local dis_max, speed_mul = nil

	if angle <= my_data.vision.cone_1.angle / 2 and dis < my_data.vision.cone_1.distance * range_mul then
		speed_mul = my_data.vision.cone_1.speed_mul
		dis_max = my_data.vision.cone_1.distance * range_mul
	elseif angle <= my_data.vision.cone_2.angle / 2 and dis < my_data.vision.cone_2.distance * range_mul then
		speed_mul = my_data.vision.cone_2.speed_mul
		dis_max = my_data.vision.cone_2.distance * range_mul
	elseif angle <= my_data.vision.cone_3.angle / 2 and dis < my_data.vision.cone_3.distance * range_mul then
		speed_mul = my_data.vision.cone_3.speed_mul
		dis_max = my_data.vision.cone_3.distance * range_mul
	else
		speed_mul = 100
		dis_max = 1
	end
	
	local dis_multiplier = dis / dis_max

	if my_data.detection.use_uncover_range and settings.uncover_range and dis < settings.uncover_range then
		-- uncover does not require FOV, regardless of what's set and has a special detection condition
		return -1, 0, 0
	end

	if dis_multiplier < 1 then
		if settings.notice_requires_FOV then
			if angle_multiplier < 1 then
				return angle, dis_multiplier, speed_mul
			end
		else
			return 0, dis_multiplier, speed_mul
		end
	end
end